<script setup lang="ts">
  // this toolbar will not handle any business logic composables.
  import { EventName, Props, emitsKey, propsKey, ToolbarMode } from './model';

  const emits = defineEmits<{
    (e: 'change', params: { event: string; data?: any }): void;
  }>();

  const props = defineProps<Props>();

  const onChange = (event: EventName, data?: any) => {
    emits('change', {
      event,
      data,
    });
  };

  provide<Props>(propsKey, props);
  provide(emitsKey, {
    onChange,
  });
</script>

<template>
  <div
    id="toolbar"
    class="z-toolbar lg:(h-[4.5rem] px-4) border-border flex h-16 items-center border-t bg-white px-3"
  >
    <!-- Toolbar for Guide -->
    <template v-if="toolbarMode === ToolbarMode.GUIDE">
      <!-- for Desktop, tablet above md -->
      <div class="hidden w-full justify-between md:flex">
        <div class="flex items-center md:gap-3 lg:gap-4">
          <SwTooltip :content="$t('guideModal')" position="topCenter" width="max-width">
            <SwButton
              fab
              :variant="props.guideToolsController?.guideBtn?.on ? 'primary' : 'action'"
              @click="onChange('toggleGuideTools')"
            >
              <template #icon>
                <span class="i-sw-solid:guide" />
              </template>
            </SwButton>
          </SwTooltip>

          <div
            v-if="!props.mediaController?.hidden"
            class="border-border hidden h-5 border-l md:block"
          />

          <MediaGroup />
        </div>

        <NavigationGroup />

        <div class="flex items-center gap-3 lg:gap-4">
          <ParticipantMenuButton />

          <div class="border-border hidden h-5 border-l md:block" />

          <InteractionGroup />
        </div>
      </div>

      <!-- for Mobile below md -->
      <div class="flex w-full justify-between md:hidden">
        <SwButton
          fab
          :variant="props.guideToolsController?.guideBtn?.on ? 'primary' : 'action'"
          @click="onChange('toggleGuideTools')"
        >
          <template #icon>
            <span class="i-sw-solid:guide" />
          </template>
        </SwButton>

        <NavigationGroup />

        <GuideMenuButton />
      </div>
    </template>

    <!-- Toolbar for Client -->
    <template v-if="toolbarMode === ToolbarMode.CLIENT">
      <!-- for Desktop, tablet above md -->
      <div class="hidden w-full justify-between md:flex">
        <div class="flex items-center md:gap-3 lg:gap-4">
          <ToolbarMeta class="hidden lg:flex" />
          <div class="border-border hidden h-5 border-l lg:block" />
          <SwTooltip :content="$t('presentation.goToGuide')" position="topCenter" width="max-width">
            <SwButton fab variant="action" @click="onChange('goTo')">
              <template #icon>
                <span class="i-sw-solid:crosshair"></span>
              </template>
            </SwButton>
          </SwTooltip>
        </div>
        <MediaGroup />

        <div class="flex items-center gap-3 lg:gap-4">
          <ParticipantMenuButton />

          <div class="border-border hidden h-5 border-l md:block md:flex" />

          <InteractionGroup />
        </div>
      </div>

      <!-- for Mobile below md -->
      <div class="flex w-full justify-between md:hidden">
        <MediaGroup />
        <div class="flex items-center gap-3">
          <ClientMenuButton />

          <SwTooltip :content="$t('cart')" position="topCenter" width="max-width">
            <SwButton
              fab
              variant="action"
              :badge="props?.interactionController?.cartBtn?.count"
              @click="onChange('toggleCart')"
            >
              <template #icon>
                <span class="i-sw-solid:shopping-cart" />
              </template>
            </SwButton>
          </SwTooltip>
        </div>
      </div>
    </template>

    <!-- Toolbar for Self -->
    <template v-if="toolbarMode === ToolbarMode.SELF">
      <!-- for Desktop, tablet above md -->
      <div class="hidden w-full justify-between md:flex">
        <ToolbarMeta class="hidden md:flex" />

        <NavigationGroup />

        <InteractionGroup />
      </div>

      <!-- for Mobile below md -->
      <div class="flex w-full justify-between md:hidden">
        <NavigationGroup />
        <InteractionGroup />
      </div>
    </template>
  </div>
</template>
